package de.cscherr.mcpht.config;

import de.cscherr.mcpht.MCPHTClient;
import de.cscherr.mcpht.mixin.client.NetworkPacketLogMixin;
import me.shedaniel.autoconfig.ConfigData;
import me.shedaniel.autoconfig.annotation.Config;
import me.shedaniel.autoconfig.annotation.ConfigEntry;
import java.util.regex.Pattern;

@Config(name = "mcphtconf")
public class MCPHTConfig implements ConfigData {
    @ConfigEntry.Category("Networking")
    @ConfigEntry.Gui.CollapsibleObject
    public NetworkLoggingScheme networkLogging = new NetworkLoggingScheme();

    public void onSave() {
        MCPHTClient.LOGGER.info("saving and processing configs");
        compileFilter();
    }

    public void onLoad() {
        MCPHTClient.LOGGER.info("loading configs");
        compileFilter();
    }

    private void compileFilter() {
    try {
        this.networkLogging.pattern = Pattern.compile(".*");
    }
    catch (Exception e) {
        MCPHTClient.LOGGER.error(e.getMessage());
        }
    }

    public static class NetworkLoggingScheme {
        public boolean RX = false;
        public boolean TX = false;
        public NetworkPacketVerbosity verbosity = NetworkPacketVerbosity.NAME;
        public String regex = "";
        public enum NetworkPacketVerbosity {
            ALL,
            NAME
        }
        @ConfigEntry.Gui.Excluded
        public Pattern pattern;
    }
}
